<?php
/*
Plugin Name: aNobii WordPress Widget
Plugin URI: http://www.jhack.it/wp-anobii
Description: The first plugin which integrates aNobii in Wordpress as a widget
Author: Giacomo Boccardo
Version: 0.7
Author URI: http://www.jhack.it


Copyright 2007  Giacomo Boccardo  (email : gboccard@gmail.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/



// Variabili
define('anobiiDirpath','/wp-content/plugins' . strrchr(dirname(__FILE__),'/') . '/');


define("key_anobii_url", "anobii_url", true);
define("key_nBooks", "nBooks", true);


//add_option(key_anobii_url, anobii_url_default, "Default aNobii profile URL");
//add_option(key_nBooks, anobii_nBooks_default, "Number of books to display");



$anobii_defaults = array(
	'anobii_url'	=> '',
	'nBooks'		=> 6,
	'widgetTitle'	=> 'aNobii',
	'showCredits'	=> 1
);

function anobii_options_page() {
	
	global $anobii_defaults;
	

		
	// If it's called after a POST...
 	if (isset($_POST['anobii_submit'])) 
	{
		$options = (array) get_option('anobii_options');
			
		$options['anobii_url'] 	= strip_tags(stripslashes($_POST['anobii_url']));
		$options['nBooks'] 		= intval($_POST['nBooks']);

		update_option('anobii_options', $options);
	
		// Update message
		echo "<div class='updated'><p><strong>aNobii Options Updated</strong></p></div>";
	}
	
	$options = get_option('anobii_options');

	$anobii_url 	= ( $options['anobii_url'] != '' ) ? $options['anobii_url'] : $anobii_defaults['anobii_url'];
	$nBooks 		= ( $options['nBooks'] != '' ) ? $options['nBooks'] : $anobii_defaults['nBooks'];
	
	
	
	
	?>
			
		
	<form method="post" action="options-general.php?page=aNobii.php">

		<div class="wrap">
			<h2>aNobii Plugin Options</h2>
			<p>
				In the following extremely complex form you need to specify the url to the main page of your aNobii's profile using the <strong>alphanumeric format</strong>. 
				<br/>
				If you chose a short format for your aNobii url (e.g.: <a href="http://www.anobii.com/people/jhack">http://www.anobii.com/people/jhack</a> ) you must retrieve your user-id from the Feed RSS url near to the bottom of your aNobii's Home Profile.
				<br />
				Therefore the url you must provide here must be something like <a href="http://www.anobii.com/people/010c51b082b89840a7"> http://www.anobii.com/people/010c51b082b89840a7 </a>.
			
			</p>
			<br/>
			<br/>

			<label for="<?php echo key_anobii_url; ?>">URL (with alphanumeric ID):</label>

			<?php

				
				echo "<input type='text' size='50' ";
				echo "name='".key_anobii_url."' ";
				echo "id='".key_anobii_url."' ";
				echo "value='".stripslashes( $options['anobii_url'] )."' />\n";
			?>
			
			<br/>
			<br/>

			<label for="<?php echo key_nBooks; ?>">Number of books to display:</label>
			<select id="<?php echo key_nBooks; ?>" name="<?php echo key_nBooks; ?>">
				<?php

					for ($i=1; $i<11; $i++)
					{
						$selected = "";
						if ( $i == $options['nBooks'] ) $selected="selected=selected";
						echo "<option value='$i' $selected>$i</option>";
					}
				?>
			</select>	
										
			<p class="submit">
				<input type='submit' name='anobii_submit' value='Update Options' />
			</p>
		</div>
	</form>
		
	
	<?php
}




function anobii_options_menu() {
	add_options_page('aNobii Plugin Options', 'aNobii Plugin', 8, basename(__FILE__), 'anobii_options_page');
}




function anobii_widget($args)
{
	global $anobii_defaults;
	extract($args);
	
	?>
	
<!--	<li id="anobii" class="widget widget_anobii">
		<h2 class="widgettitle">aNobii</h2>
-->

		<?php
		
			echo $before_widget;

			
		
			$options = (array) get_option('anobii_options');
			
			$widgetTitle 	= ( $options['widgetTitle'] != '' ) ? $options['widgetTitle'] : $anobii_defaults['widgetTitle'];
			$showCredits 	= isset($options['showCredits']) ? $options['showCredits'] : $anobii_defaults['showCredits'];
				
			// http://www.anobii.com/people/$uid
			$uid = basename($options['anobii_url']);
			$nBooks = $options['nBooks'];
			$curPath = get_option('siteurl').anobiiDirpath;
		
			echo "<h2>" . $options['widgetTitle'] . "</h2><ul id=\"anobii_widget\"><li>";

	
				echo "<div id=\"anobiiContent\">";

					echo "<div id=\"anobiiHeader\">";
				
						echo "<div id=\"anobiiProfile\"> <a target=\"_blank\" href=\"http://www.anobii.com/people/$uid\">aNobii Profile</a> </div>";
				
						echo "<div id=\"anobiiReload\"> <a  href=\"#\" onclick=\"javascript:reload();return false;\"><img src=\"$curPath/images/reload.png\" alt=\"Reload the widget\" title=\"Reload the widget\" /></a></div>"; 

					echo "</div>";


					echo "<div id=\"anobiiBooks\">";
						echo "Reload me, please :(";
					echo "</div>";
					
					if ( ! $showCredits ) $hide = 'class="hide"';

					echo '<div id="anobiiCredits" '. $hide.'>developed by <a href="http://www.jhack.it">Jhack</a></div>';
					
				echo "</div>";
		
		

				echo "	<script src=\"" . $curPath . "aNobiiWidget.js\" type=\"text/javascript\"></script>\n";

				echo "	<script type=\"text/javascript\">init(\"$curPath\", \"$uid\", $nBooks);</script>\n";
		
			echo "</li></ul>";
			
			echo $after_widget; 
		?>

<!-- 	</li> -->
	
	<?php
}

function anobii_widget_control()
{
	global $anobii_defaults;
	
	if ( $_POST['anobii_submit'] )
	{
		$options = (array) get_option('anobii_options');
					
		$options['widgetTitle'] 	= strip_tags(stripslashes($_POST['anobii_widgetTitle']));
		$options['showCredits'] 	= isset($_POST['anobii_showCredits']);
		
		update_option('anobii_options', $options);
	}
	
	$options = get_option('anobii_options');
	

	
	$widgetTitle 	= ( $options['widgetTitle'] != '' ) ? $options['widgetTitle'] : $anobii_defaults['widgetTitle'];
	$showCredits 	= isset($options['showCredits']) ? ( $options['showCredits'] ? 'checked="checked"' : '' ) : 'checked="checked"';
	

	echo '<p style="text-align:right;"><label for="anobii_widgetTitle">Widget Title: <input style="width: 100px;" id="anobii_widgetTitle" name="anobii_widgetTitle" type="text" value="'.$widgetTitle.'" /></label></p>';
	echo '<p style="text-align:right;"><label for="anobii_showCredits">Show credits: <input style="width: 100px;" '. $showCredits.' type="checkbox" id="anobii_showCredits" name="anobii_showCredits"  /></label></p>';	

	echo '<input type="hidden" id="anobii_submit" name="anobii_submit" value="1" />';
}

function anobii_widget_init()
{	
	// Check if the environment supports widgets
	if (!function_exists('register_sidebar_widget'))
    	return;
	
	register_sidebar_widget(array('aNobii Widget', 'widgets'), 'anobii_widget');
	register_widget_control(array('aNobii Widget', 'widgets'), 'anobii_widget_control', 200, 100);
}


function anobii_stylesheet() 
{
	$curPath = get_option('siteurl').anobiiDirpath;
	
	echo "<link rel=\"stylesheet\" href=\"".$curPath."css/aNobiiStyle.css\" type=\"text/css\" media=\"screen\" />";	
}


// Create the option menu
add_action('admin_menu', 'anobii_options_menu' );

// Initialize the widget
add_action('widgets_init', 'anobii_widget_init');

// Add stylesheet to head
add_action('wp_head', 'anobii_stylesheet');



?>
